import numpy as np
import h5py
import sys

B1_ARRAY=[.1, .3, .6, 1.0, 1.3, 1.6, 1.9, 2.0]
B3_ARRAY=[.1, .3, .6, 1.0, 1.3, 1.6, 1.9, 2.0]
A2_ARRAY=[.1, .3, .6, 1.0, 1.3, 1.6, 1.9, 2.0]
A4_ARRAY=[.1, .3, .6, 1.0, 1.3, 1.6, 1.9, 2.0]

argarrays = [A2_ARRAY, A4_ARRAY, B1_ARRAY, B3_ARRAY]

def proc_line(in_str):
    return np.fromstring(in_str, sep=" ")

def proc_timestep(timestep_str):
    stripped_prefix = timestep_str.split("\n")[8:]
    t__ = int(timestep_str.split("\n")[0])
    lines = [proc_line(l) for l in stripped_prefix[:-1]]
    #print(t__, len(stripped_prefix), lines[0].shape, stripped_prefix[0])
    rez = np.vstack(
        sorted(lines, key=lambda x: x[0])
    )
    print(rez[:10, :10])
    return rez
    
def split_to_timesteps(full_str):
    return full_str.split("ITEM: TIMESTEP\n")

if __name__ == '__main__':  
    testfile = open(sys.argv[1],'r')
    test = split_to_timesteps(testfile.read())
    print(len(test))

    processed_indiv = [proc_timestep(item) for item in test[1:-1]]
    processed = np.stack(processed_indiv)
    print(processed.shape)
    the_name = sys.argv[1].split("/")[-1].split(".")[0]
    name_args = the_name.split("_")
    arg_idxs = [int(item) for item in name_args[:-1]]
    args = [argarrays[i][arg_idxs[i]] for i in range(len(arg_idxs))]
    with h5py.File('processed_data/'+the_name+".h5", 'w') as hf:
        hf.create_dataset("data",  data=processed)
        hf.create_dataset("args",  data=np.array(args))
